# -*- coding: utf-8 -*-
"""
Created on Sat Feb 24 00:07:11 2018

@author: Callie Darsey

Perimeter example
"""

import numpy as np
import cv2
import exploring_histogram_creation_01 as my_print
import toy_problem_place_cc as place

#I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,  247,  193,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,  138,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,   45,  189,    0,    0,    0,    0,    0,    0],
#              [    0,    0,  219,    1,   18,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    2,   59,    0,    0,    0,    0,    0],
#              [    0,    0,   36,    0,   17,    0,    0,    0,    0,    0],
#              [    0,    0,  115,    0,  195,  126,    0,    0,    0,    0],
#              [    0,    0,    0,   87,    0,  128,  245,    0,    0,    0],
#              [    0,    0,    0,    0,    0,  199,  150,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,  222,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,  222,    0,  222,  222],
#              [    0,    0,    0,    0,    0,    0,  222,    0,    0,  222],
#              [    0,    0,    0,    0,    0,    0,  222,  222,  222,  222]],
#             dtype=np.uint8)

#I = np.array([[    0,    0,    1,    1,    1,    0,    0,    0,    0,    0],
#              [    1,    1,    1,    0,    0,    0,    0,    1,    0,    0],
#              [    0,    0,    1,    1,    1,    1,    1,    1,    0,    0],
#              [    0,    0,    0,    1,    1,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    1,    0,    1,    1,    1,    1,    0],
#              [    0,    0,    0,    0,    1,    0,    0,    0,    1,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    1,    1],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    1],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
#             dtype=np.uint8)

I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    1,    0,    0,    0],
              [    0,    0,    0,    0,    0,    1,    1,    1,    0,    0],
              [    0,    0,    0,    0,    0,    0,    1,    1,    1,    0],
              [    0,    0,    0,    0,    0,    0,    0,    1,    1,    1],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
             dtype=np.uint8)

I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    1,    0,    0,    0],
              [    0,    0,    0,    1,    1,    1,    0,    0,    0,    0],
              [    0,    0,    1,    1,    1,    0,    0,    0,    0,    0],
              [    0,    1,    1,    1,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
             dtype=np.uint8)



I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
             dtype=np.uint8)

I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    1,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    1,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    1,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    1,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    1,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    1,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    1,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    1]],
             dtype=np.uint8)

I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    1],
              [    0,    0,    0,    0,    0,    0,    0,    0,    1,    0],
              [    0,    0,    0,    0,    0,    0,    0,    1,    0,    0],
              [    0,    0,    0,    0,    0,    0,    1,    0,    0,    0],
              [    0,    0,    0,    0,    0,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    0,    0,    0,    0,    0],
              [    0,    0,    0,    1,    0,    0,    0,    0,    0,    0],
              [    0,    0,    1,    0,    0,    0,    0,    0,    0,    0],
              [    0,    1,    0,    0,    0,    0,    0,    0,    0,    0],
              [    1,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
             dtype=np.uint8)

I = np.array([[    1,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    1,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    1,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    1,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    1,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    1,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    1,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    1],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
             dtype=np.uint8)

I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    1],
              [    0,    0,    0,    0,    0,    0,    0,    0,    1,    0],
              [    0,    0,    0,    0,    0,    0,    0,    1,    0,    0],
              [    0,    0,    0,    0,    0,    0,    1,    0,    0,    0],
              [    0,    0,    0,    0,    0,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    0,    0,    0,    0,    0],
              [    0,    0,    0,    1,    0,    0,    0,    0,    0,    0],
              [    0,    0,    1,    0,    0,    0,    0,    0,    0,    0],
              [    0,    1,    0,    0,    0,    0,    0,    0,    0,    0],
              [    1,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
             dtype=np.uint8)
''''''

I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    1,    0,    0,    0,    0,    0,    0,    0],
              [    0,    1,    1,    1,    0,    0,    0,    0,    0,    0],
              [    0,    0,    1,    1,    1,    0,    0,    0,    0,    0],
              [    0,    0,    0,    1,    1,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    1,    0,    0,    0],
              [    0,    0,    0,    0,    0,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
             dtype=np.uint8)

I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    1,    0,    0],
              [    0,    0,    0,    0,    0,    0,    1,    1,    1,    0],
              [    0,    0,    0,    0,    0,    1,    1,    1,    0,    0],
              [    0,    0,    0,    0,    1,    1,    1,    0,    0,    0],
              [    0,    0,    0,    1,    1,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
             dtype=np.uint8)

#I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    1,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    1,    1,    1,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    1,    1,    1,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    1,    1,    1,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    1,    1,    1,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    1,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
#             dtype=np.uint8)

#I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    1,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    1,    1,    1,    0,    0,    0],
#              [    0,    0,    0,    1,    1,    1,    0,    0,    0,    0],
#              [    0,    0,    1,    1,    1,    0,    0,    0,    0,    0],
#              [    0,    1,    1,    1,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    1,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
#             dtype=np.uint8)

I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    1,    1,    1,    1,    1,    1,    1,    0],
              [    0,    0,    1,    1,    1,    1,    1,    1,    1,    0],
              [    0,    0,    1,    1,    1,    1,    1,    1,    1,    0],
              [    0,    0,    1,    1,    1,    1,    1,    1,    1,    0],
              [    0,    0,    1,    1,    1,    1,    1,    1,    1,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
             dtype=np.uint8)

I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
             dtype=np.uint8)

I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    1,    1,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
             dtype=np.uint8)

#I = np.array([[    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    1,    1,    1,    1,    1,    1,    1,    0,    0],
#              [    0,    1,    1,    1,    1,    1,    1,    1,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0],
#              [    0,    0,    0,    0,    0,    0,    0,    0,    0,    0]],
#             dtype=np.uint8)

#my_print.print_one_channel_image(I)

kernel = np.ones((3,3))
I_d = cv2.dilate(I, kernel)

#my_print.print_one_channel_image(I_d)


I_1v = I.astype(np.bool).astype(np.uint8) * 255
my_print.print_one_channel_image(I_1v)
print('I_1v.shape', I_1v.shape)

contours = cv2.findContours(I_1v, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)

contour_points = contours[1][0].reshape((contours[1][0].shape[0], -1))

min_area_rect_info = cv2.minAreaRect(contour_points)

rotated_rect_points = cv2.boxPoints(min_area_rect_info)

rotated_rect_points_ints = np.int0(rotated_rect_points)
rotated_rect_points_ints = np.int0(np.around(rotated_rect_points))

color_I_1v = np.stack([I_1v, I_1v, I_1v], axis=2)

cv2.drawContours(color_I_1v,[rotated_rect_points_ints], -1, (0,0,255), 1)

print('min_area_rect_info')
print(min_area_rect_info)
print('rotated_rect_points')
print(rotated_rect_points)
print('rotated_rect_points_ints')
print(rotated_rect_points_ints)



#cv2.imshow('image', I)
#cv2.imshow('nonzero pixels', I.astype(np.bool).astype(np.uint8) * 255)
#cv2.imshow('dilate', I_d)
cv2.imshow('one value', I_1v)
cv2.imshow('with min. rotated rect.', color_I_1v)



cv2.waitKey(0)

cv2.destroyAllWindows()