# -*- coding: utf-8 -*-
"""
Created on Thu Apr  5 22:47:49 2018

@author: Callie Darsey


"""

import numpy as np

action_frames = [[0, 24], [36], [52,84], [108,124], [176,188], [364, 412],
                 [420, 428], [84], [172], [256, 308], [316], [324, 332],
                 [388, 460], [28, 56], [180, 220], [244, 292], [264, 300],
                 [156, 172], [180, 200], [224, 234]]

action_frame_numbers = []

for rng in action_frames:
    
    if len(rng) == 1:
        
        action_frame_numbers.append(rng[0])
        
    elif len(rng) == 2:
        
        action_frame_numbers.append(np.arange(rng[0], rng[1] + 1, 4))
        
    else:
        
        print('huh?')
        
unique_afn = np.unique(np.hstack(action_frame_numbers))

no_strong_action = []

for fn in np.arange(0, 461, 4):
    
    if fn not in unique_afn:
        
        no_strong_action.append(fn)


