# -*- coding: utf-8 -*-
"""
Created on Tue Jan 23 13:42:18 2018

@author: Callie Darsey

example for bounding box and selecting region
"""

import cv2

# Read image
im = cv2.imread("C:\\Users\\Callie\\" + \
                "ECE_633_Adv_Topics_in_Image_Processing\\" + \
                "Class_Project\\presentation\\" + \
                "mouth_movement_not_captured_02.PNG")
 
# Select ROI
r = cv2.selectROI(im, False)
 
# Crop image
imCrop = im[int(r[1]):int(r[1]+r[3]), int(r[0]):int(r[0]+r[2])]
 
# Display cropped image
cv2.imshow("Image", imCrop)
cv2.waitKey(0)