# -*- coding: utf-8 -*-
"""
Created on Fri Mar 23 22:50:50 2018

@author: Callie Darsey

get specific video

hardcode path

get_specific_video_01
"""


import json
from ftplib import FTP_TLS
import numpy as np
import cv2
from matplotlib import pyplot as plt
import pickle
import os

# names of .json file used for storage
ftp_loc_mp4 = './video_copies_clips_track/track/ftp_loc_mp4.json'

ftp_loc_mp4_visited = './video_copies_clips_track/track/ftp_loc_mp4_visited.json'

# I move by hand info for videos not of interest to this file
ftp_loc_mp4_visited_not_useful = './video_copies_clips_track/track/' + \
                                 'ftp_loc_mp4_visited_not_useful.json'

# load the dictionaries from the .json files
with open(ftp_loc_mp4, 'r') as f:
    loc_dic = json.load(f)
    
with open(ftp_loc_mp4_visited, 'r') as f:
    visited_loc_dic = json.load(f)
    
with open(ftp_loc_mp4_visited_not_useful, 'r') as f:
    not_useful_loc_dic = json.load(f)
    

# hardcode the specifit ftp path    
ftp_loc = ''
    
path, mp4name = os.path.split(ftp_loc)


higher_path, deepest_folder = os.path.split(path)

# copy the .mp4 from the ftp
ftp = FTP_TLS("129.24.28.223")
print("Welcome: ", ftp.getwelcome())
ftp.auth()
ftp.prot_p()
ftp.login(user='cdarsey', passwd='xyz123693')

ftp.cwd(path)

holding_dir = os.path.join('./video_copies_clips_track/copies_and_clips_wave_03/',
                           deepest_folder)
if not os.path.isdir(holding_dir):
    os.mkdir(holding_dir)

if not os.path.isdir(os.path.join(holding_dir, mp4name[:-4])):
    os.mkdir(os.path.join(holding_dir, mp4name[:-4]))
    
filedata = open(os.path.join(holding_dir, mp4name), 'wb') 
ftp.retrbinary('RETR '+mp4name, filedata.write) 
filedata.close() 

ftp.quit()

# record that mp4 on the ftp as visited  
print(ftp_loc)
visited_loc_dic[key].append(ftp_loc)

# save the new visited dictionary to the .json file
with open(ftp_loc_mp4_visited, 'w') as f:
    json.dump(visited_loc_dic, f)

# finish with a print statement
video_path = holding_dir+mp4name
print(video_path)

